% piston_stag.m

close all;clear
set(0,'DefaultAxesFontSize',20)

N = 21;
tau = 0.1;
m = 30.77;
omega2 = 3.03E-4;

[A,B,C,D] = use_discretisation(N, m, omega2);

u0 = zeros(2*N+2,1);
u0(2*N+2) = 1;

t = 0;

mat21 = eye(2*N) - tau*A;
mat22 = eye(2) - tau*D;
imat21 = inv(mat21);
imat22 = inv(mat22);
 
u2 = u0(1:2*N);
v2 = u0(2*N+1:2*N+2);
U2 = v2(1);

T = t;
while t < 1200;
  t = t + tau;
  u2 = imat21*(u2 + tau*B*v2);
  v2 = imat22*(v2 + tau*C*u2);
  
  U2 = [U2,v2(1)];
  T = [T,t];  
end  

figure,
plot(T,U2, 'LineWidth',2)
xlabel('time t');
ylabel('displacement q');
print -dpng result_staggered.png